"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    SearchRequest,
    avro_parse,
    load_schema,
)


class SearchCallSetsRequest(SearchRequest):
    """
    This request maps to the body of `POST /callsets/search` as JSON.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "variantSetId",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_9_0 import ga4gh as ga4gh_3_1_1

        return {
            "org.ga4gh.methods.SearchCallSetsRequest": ga4gh_3_1_1.SearchCallSetsRequest,
        }

    __slots__ = [
        "variantSetId",
        "name",
        "pageSize",
        "pageToken",
    ]

    def __init__(
        self,
        variantSetId,
        name=None,
        pageSize=None,
        pageToken=None,
        validate=None,
        **kwargs
    ):
        """Initialise the ga4gh_3_1_1.SearchCallSetsRequest model.

        :param variantSetId:
            The VariantSet to search.
        :type variantSetId: str
        :param name:
            Only return call sets with this name (case-sensitive, exact match).
        :type name: None | str
        :param pageSize:
            Specifies the maximum number of results to return in a single page. If
            unspecified, a system default will be used.
        :type pageSize: None | int
        :param pageToken:
            The continuation token, which is used to page through large result
            sets. To get the next page of results, set this parameter
            to the value of `nextPageToken` from the previous
            response.
        :type pageToken: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "3.1.1"
